%ifndef INCLUDED_VXDN_INC
%define INCLUDED_VXDN_INC

%macro VxD_Service 1
  %1 EQU (__Cur_VxD_ID << 16) | __Cur_VxD_Service
  %assign __Cur_VxD_Service __Cur_VxD_Service+1
%endmacro

%macro Declare_VxD 2
  %1_Device_ID EQU %2
  %define %1_Service VxD_Service
  %assign __Cur_VxD_ID %2
  %assign __Cur_VxD_Service 0
%endmacro

%define End_Declare_VxD

Declare_VxD VMM, 0x0001
  VMM_Service Get_VMM_Version                          ; 0x0000 ord
  VMM_Service Get_Cur_VM_Handle                        ; 0x0001 ord
  VMM_Service Test_Cur_VM_Handle                       ; 0x0002 ord
  VMM_Service Get_Sys_VM_Handle                        ; 0x0003 ord
  VMM_Service Test_Sys_VM_Handle                       ; 0x0004 ord
  VMM_Service Validate_VM_Handle                       ; 0x0005 ord
  VMM_Service Get_VMM_Reenter_Count                    ; 0x0006 ord
  VMM_Service Begin_Reentrant_Execution                ; 0x0007 ord
  VMM_Service End_Reentrant_Execution                  ; 0x0008 ord
  VMM_Service Install_V86_Break_Point                  ; 0x0009 ord
  VMM_Service Remove_V86_Break_Point                   ; 0x000a ord
  VMM_Service Allocate_V86_Call_Back                   ; 0x000b ord
  VMM_Service Allocate_PM_Call_Back                    ; 0x000c ord
  VMM_Service Call_When_VM_Returns                     ; 0x000d ord
  VMM_Service Schedule_Global_Event                    ; 0x000e ord
  VMM_Service Schedule_VM_Event                        ; 0x000f ord
  VMM_Service Call_Global_Event                        ; 0x0010 ord
  VMM_Service Call_VM_Event                            ; 0x0011 ord
  VMM_Service Cancel_Global_Event                      ; 0x0012 ord
  VMM_Service Cancel_VM_Event                          ; 0x0013 ord
  VMM_Service Call_Priority_VM_Event                   ; 0x0014 ord
  VMM_Service Cancel_Priority_VM_Event                 ; 0x0015 ord
  VMM_Service Get_NMI_Handler_Addr                     ; 0x0016 ord
  VMM_Service Set_NMI_Handler_Addr                     ; 0x0017 ord
  VMM_Service Hook_NMI_Event                           ; 0x0018 ord
  VMM_Service Call_When_VM_Ints_Enabled                ; 0x0019 ord
  VMM_Service Enable_VM_Ints                           ; 0x001a ord
  VMM_Service Disable_VM_Ints                          ; 0x001b ord
  VMM_Service Map_Flat                                 ; 0x001c ord
  VMM_Service Map_Lin_To_VM_Addr                       ; 0x001d ord
  VMM_Service Adjust_Exec_Priority                     ; 0x001e ord
  VMM_Service Begin_Critical_Section                   ; 0x001f ord
  VMM_Service End_Critical_Section                     ; 0x0020 ord
  VMM_Service End_Crit_And_Suspend                     ; 0x0021 ord
  VMM_Service Claim_Critical_Section                   ; 0x0022 ord
  VMM_Service Release_Critical_Section                 ; 0x0023 ord
  VMM_Service Call_When_Not_Critical                   ; 0x0024 ord
  VMM_Service Create_Semaphore                         ; 0x0025 ord
  VMM_Service Destroy_Semaphore                        ; 0x0026 ord
  VMM_Service Wait_Semaphore                           ; 0x0027 ord
  VMM_Service Signal_Semaphore                         ; 0x0028 ord
  VMM_Service Get_Crit_Section_Status                  ; 0x0029 ord
  VMM_Service Call_When_Task_Switched                  ; 0x002a ord
  VMM_Service Suspend_VM                               ; 0x002b ord
  VMM_Service Resume_VM                                ; 0x002c ord
  VMM_Service No_Fail_Resume_VM                        ; 0x002d ord
  VMM_Service Nuke_VM                                  ; 0x002e ord
  VMM_Service Crash_Cur_VM                             ; 0x002f ord
  VMM_Service Get_Execution_Focus                      ; 0x0030 ord
  VMM_Service Set_Execution_Focus                      ; 0x0031 ord
  VMM_Service Get_Time_Slice_Priority                  ; 0x0032 ord
  VMM_Service Set_Time_Slice_Priority                  ; 0x0033 ord
  VMM_Service Get_Time_Slice_Granularity               ; 0x0034 ord
  VMM_Service Set_Time_Slice_Granularity               ; 0x0035 ord
  VMM_Service Get_Time_Slice_Info                      ; 0x0036 ord
  VMM_Service Adjust_Execution_Time                    ; 0x0037 ord
  VMM_Service Release_Time_Slice                       ; 0x0038 ord
  VMM_Service Wake_Up_VM                               ; 0x0039 ord
  VMM_Service Call_When_Idle                           ; 0x003a ord
  VMM_Service Get_Next_VM_Handle                       ; 0x003b ord
  VMM_Service Set_Global_Time_Out                      ; 0x003c ord
  VMM_Service Set_VM_Time_Out                          ; 0x003d ord
  VMM_Service Cancel_Time_Out                          ; 0x003e ord
  VMM_Service Get_System_Time                          ; 0x003f ord
  VMM_Service Get_VM_Exec_Time                         ; 0x0040 ord
  VMM_Service Hook_V86_Int_Chain                       ; 0x0041 ord
  VMM_Service Get_V86_Int_Vector                       ; 0x0042 ord
  VMM_Service Set_V86_Int_Vector                       ; 0x0043 ord
  VMM_Service Get_PM_Int_Vector                        ; 0x0044 ord
  VMM_Service Set_PM_Int_Vector                        ; 0x0045 ord
  VMM_Service Simulate_Int                             ; 0x0046 ord
  VMM_Service Simulate_Iret                            ; 0x0047 ord
  VMM_Service Simulate_Far_Call                        ; 0x0048 ord
  VMM_Service Simulate_Far_Jmp                         ; 0x0049 ord
  VMM_Service Simulate_Far_Ret                         ; 0x004a ord
  VMM_Service Simulate_Far_Ret_N                       ; 0x004b ord
  VMM_Service Build_Int_Stack_Frame                    ; 0x004c ord
  VMM_Service Simulate_Push                            ; 0x004d ord
  VMM_Service Simulate_Pop                             ; 0x004e ord
  VMM_Service _HeapAllocate                            ; 0x004f ord
  VMM_Service _HeapReAllocate                          ; 0x0050 ord
  VMM_Service _HeapFree                                ; 0x0051 ord
  VMM_Service _HeapGetSize                             ; 0x0052 ord
  VMM_Service _PageAllocate                            ; 0x0053 ord
  VMM_Service _PageReAllocate                          ; 0x0054 ord
  VMM_Service _PageFree                                ; 0x0055 ord
  VMM_Service _PageLock                                ; 0x0056 ord
  VMM_Service _PageUnLock                              ; 0x0057 ord
  VMM_Service _PageGetSizeAddr                         ; 0x0058 ord
  VMM_Service _PageGetAllocInfo                        ; 0x0059 ord
  VMM_Service _GetFreePageCount                        ; 0x005a ord
  VMM_Service _GetSysPageCount                         ; 0x005b ord
  VMM_Service _GetVMPgCount                            ; 0x005c ord
  VMM_Service _MapIntoV86                              ; 0x005d ord
  VMM_Service _PhysIntoV86                             ; 0x005e ord
  VMM_Service _TestGlobalV86Mem                        ; 0x005f ord
  VMM_Service _ModifyPageBits                          ; 0x0060 ord
  VMM_Service _CopyPageTable                           ; 0x0061 ord
  VMM_Service _LinMapIntoV86                           ; 0x0062 ord
  VMM_Service _LinPageLock                             ; 0x0063 ord
  VMM_Service _LinPageUnLock                           ; 0x0064 ord
  VMM_Service _SetResetV86Pageable                     ; 0x0065 ord
  VMM_Service _GetV86PageableArray                     ; 0x0066 ord
  VMM_Service _PageCheckLinRange                       ; 0x0067 ord
  VMM_Service _PageOutDirtyPages                       ; 0x0068 ord
  VMM_Service _PageDiscardPages                        ; 0x0069 ord
  VMM_Service _GetNulPageHandle                        ; 0x006a ord
  VMM_Service _GetFirstV86Page                         ; 0x006b ord
  VMM_Service _MapPhysToLinear                         ; 0x006c ord
  VMM_Service _GetAppFlatDSAlias                       ; 0x006d ord
  VMM_Service _SelectorMapFlat                         ; 0x006e ord
  VMM_Service _GetDemandPageInfo                       ; 0x006f ord
  VMM_Service _GetSetPageOutCount                      ; 0x0070 ord
  VMM_Service Hook_V86_Page                            ; 0x0071 ord
  VMM_Service _Assign_Device_V86_Pages                 ; 0x0072 ord
  VMM_Service _DeAssign_Device_V86_Pages               ; 0x0073 ord
  VMM_Service _Get_Device_V86_Pages_Array              ; 0x0074 ord
  VMM_Service MMGR_SetNULPageAddr                      ; 0x0075 ord
  VMM_Service _Allocate_GDT_Selector                   ; 0x0076 ord
  VMM_Service _Free_GDT_Selector                       ; 0x0077 ord
  VMM_Service _Allocate_LDT_Selector                   ; 0x0078 ord
  VMM_Service _Free_LDT_Selector                       ; 0x0079 ord
  VMM_Service _BuildDescriptorDWORDs                   ; 0x007a ord
  VMM_Service _GetDescriptor                           ; 0x007b ord
  VMM_Service _SetDescriptor                           ; 0x007c ord
  VMM_Service _MMGR_Toggle_HMA                         ; 0x007d ord
  VMM_Service Get_Fault_Hook_Addrs                     ; 0x007e ord
  VMM_Service Hook_V86_Fault                           ; 0x007f ord
  VMM_Service Hook_PM_Fault                            ; 0x0080 ord
  VMM_Service Hook_VMM_Fault                           ; 0x0081 ord
  VMM_Service Begin_Nest_V86_Exec                      ; 0x0082 ord
  VMM_Service Begin_Nest_Exec                          ; 0x0083 ord
  VMM_Service Exec_Int                                 ; 0x0084 ord
  VMM_Service Resume_Exec                              ; 0x0085 ord
  VMM_Service End_Nest_Exec                            ; 0x0086 ord
  VMM_Service Allocate_PM_App_CB_Area                  ; 0x0087 ord
  VMM_Service Get_Cur_PM_App_CB                        ; 0x0088 ord
  VMM_Service Set_V86_Exec_Mode                        ; 0x0089 ord
  VMM_Service Set_PM_Exec_Mode                         ; 0x008a ord
  VMM_Service Begin_Use_Locked_PM_Stack                ; 0x008b ord
  VMM_Service End_Use_Locked_PM_Stack                  ; 0x008c ord
  VMM_Service Save_Client_State                        ; 0x008d ord
  VMM_Service Restore_Client_State                     ; 0x008e ord
  VMM_Service Exec_VxD_Int                             ; 0x008f ord
  VMM_Service Hook_Device_Service                      ; 0x0090 ord
  VMM_Service Hook_Device_V86_API                      ; 0x0091 ord
  VMM_Service Hook_Device_PM_API                       ; 0x0092 ord
  VMM_Service System_Control                           ; 0x0093 ord
  VMM_Service Simulate_IO                              ; 0x0094 ord
  VMM_Service Install_Mult_IO_Handlers                 ; 0x0095 ord
  VMM_Service Install_IO_Handler                       ; 0x0096 ord
  VMM_Service Enable_Global_Trapping                   ; 0x0097 ord
  VMM_Service Enable_Local_Trapping                    ; 0x0098 ord
  VMM_Service Disable_Global_Trapping                  ; 0x0099 ord
  VMM_Service Disable_Local_Trapping                   ; 0x009a ord
  VMM_Service List_Create                              ; 0x009b ord
  VMM_Service List_Destroy                             ; 0x009c ord
  VMM_Service List_Allocate                            ; 0x009d ord
  VMM_Service List_Attach                              ; 0x009e ord
  VMM_Service List_Attach_Tail                         ; 0x009f ord
  VMM_Service List_Insert                              ; 0x00a0 ord
  VMM_Service List_Remove                              ; 0x00a1 ord
  VMM_Service List_Deallocate                          ; 0x00a2 ord
  VMM_Service List_Get_First                           ; 0x00a3 ord
  VMM_Service List_Get_Next                            ; 0x00a4 ord
  VMM_Service List_Remove_First                        ; 0x00a5 ord
  VMM_Service _AddInstanceItem                         ; 0x00a6 ord
  VMM_Service _Allocate_Device_CB_Area                 ; 0x00a7 ord
  VMM_Service _Allocate_Global_V86_Data_Area           ; 0x00a8 ord
  VMM_Service _Allocate_Temp_V86_Data_Area             ; 0x00a9 ord
  VMM_Service _Free_Temp_V86_Data_Area                 ; 0x00aa ord
  VMM_Service Get_Profile_Decimal_Int                  ; 0x00ab ord
  VMM_Service Convert_Decimal_String                   ; 0x00ac ord
  VMM_Service Get_Profile_Fixed_Point                  ; 0x00ad ord
  VMM_Service Convert_Fixed_Point_String               ; 0x00ae ord
  VMM_Service Get_Profile_Hex_Int                      ; 0x00af ord
  VMM_Service Convert_Hex_String                       ; 0x00b0 ord
  VMM_Service Get_Profile_Boolean                      ; 0x00b1 ord
  VMM_Service Convert_Boolean_String                   ; 0x00b2 ord
  VMM_Service Get_Profile_String                       ; 0x00b3 ord
  VMM_Service Get_Next_Profile_String                  ; 0x00b4 ord
  VMM_Service Get_Environment_String                   ; 0x00b5 ord
  VMM_Service Get_Exec_Path                            ; 0x00b6 ord
  VMM_Service Get_Config_Directory                     ; 0x00b7 ord
  VMM_Service OpenFile                                 ; 0x00b8 ord
  VMM_Service Get_PSP_Segment                          ; 0x00b9 ord
  VMM_Service GetDOSVectors                            ; 0x00ba ord
  VMM_Service Get_Machine_Info                         ; 0x00bb ord
  VMM_Service GetSet_HMA_Info                          ; 0x00bc ord
  VMM_Service Set_System_Exit_Code                     ; 0x00bd ord
  VMM_Service Fatal_Error_Handler                      ; 0x00be ord
  VMM_Service Fatal_Memory_Error                       ; 0x00bf ord
  VMM_Service Update_System_Clock                      ; 0x00c0 ord
  VMM_Service Test_Debug_Installed                     ; 0x00c1 ord
  VMM_Service Out_Debug_String                         ; 0x00c2 ord
  VMM_Service Out_Debug_Chr                            ; 0x00c3 ord
  VMM_Service In_Debug_Chr                             ; 0x00c4 ord
  VMM_Service Debug_Convert_Hex_Binary                 ; 0x00c5 ord
  VMM_Service Debug_Convert_Hex_Decimal                ; 0x00c6 ord
  VMM_Service Debug_Test_Valid_Handle                  ; 0x00c7 ord
  VMM_Service Validate_Client_Ptr                      ; 0x00c8 ord
  VMM_Service Test_Reenter                             ; 0x00c9 ord
  VMM_Service Queue_Debug_String                       ; 0x00ca ord
  VMM_Service Log_Proc_Call                            ; 0x00cb ord
  VMM_Service Debug_Test_Cur_VM                        ; 0x00cc ord
  VMM_Service Get_PM_Int_Type                          ; 0x00cd ord
  VMM_Service Set_PM_Int_Type                          ; 0x00ce ord
  VMM_Service Get_Last_Updated_System_Time             ; 0x00cf ord
  VMM_Service Get_Last_Updated_VM_Exec_Time            ; 0x00d0 ord
  VMM_Service Test_DBCS_Lead_Byte                      ; 0x00d1 ord
  VMM_Service _AddFreePhysPage                         ; 0x00d2 ord
  VMM_Service _PageResetHandlePAddr                    ; 0x00d3 ord
  VMM_Service _SetLastV86Page                          ; 0x00d4 ord
  VMM_Service _GetLastV86Page                          ; 0x00d5 ord
  VMM_Service _MapFreePhysReg                          ; 0x00d6 ord
  VMM_Service _UnmapFreePhysReg                        ; 0x00d7 ord
  VMM_Service _XchgFreePhysReg                         ; 0x00d8 ord
  VMM_Service _SetFreePhysRegCalBk                     ; 0x00d9 ord
  VMM_Service Get_Next_Arena                           ; 0x00da ord
  VMM_Service Get_Name_Of_Ugly_TSR                     ; 0x00db ord
  VMM_Service Get_Debug_Options                        ; 0x00dc ord
  VMM_Service Set_Physical_HMA_Alias                   ; 0x00dd ord
  VMM_Service _GetGlblRng0V86IntBase                   ; 0x00de ord
  VMM_Service _Add_Global_V86_Data_Area                ; 0x00df ord
  VMM_Service GetSetDetailedVMError                    ; 0x00e0 ord
  VMM_Service Is_Debug_Chr                             ; 0x00e1 ord
  VMM_Service Clear_Mono_Screen                        ; 0x00e2 ord
  VMM_Service Out_Mono_Chr                             ; 0x00e3 ord
  VMM_Service Out_Mono_String                          ; 0x00e4 ord
  VMM_Service Set_Mono_Cur_Pos                         ; 0x00e5 ord
  VMM_Service Get_Mono_Cur_Pos                         ; 0x00e6 ord
  VMM_Service Get_Mono_Chr                             ; 0x00e7 ord
  VMM_Service Locate_Byte_In_ROM                       ; 0x00e8 ord
  VMM_Service Hook_Invalid_Page_Fault                  ; 0x00e9 ord
  VMM_Service Unhook_Invalid_Page_Fault                ; 0x00ea ord
  VMM_Service Set_Delete_On_Exit_File                  ; 0x00eb ord
  VMM_Service Close_VM                                 ; 0x00ec ord
  VMM_Service Enable_Touch_1st_Meg                     ; 0x00ed ord
  VMM_Service Disable_Touch_1st_Meg                    ; 0x00ee ord
  VMM_Service Install_Exception_Handler                ; 0x00ef ord
  VMM_Service Remove_Exception_Handler                 ; 0x00f0 ord
  VMM_Service Get_Crit_Status_No_Block                 ; 0x00f1 ord
  VMM_Service _GetLastUpdatedThreadExecTime            ; 0x00f2 ord
  VMM_Service _Trace_Out_Service                       ; 0x00f3 ord
  VMM_Service _Debug_Out_Service                       ; 0x00f4 ord
  VMM_Service _Debug_Flags_Service                     ; 0x00f5 ord
  VMM_Service VMMAddImportModuleName                   ; 0x00f6 ord
  VMM_Service VMM_Add_DDB                              ; 0x00f7 ord
  VMM_Service VMM_Remove_DDB                           ; 0x00f8 ord
  VMM_Service Test_VM_Ints_Enabled                     ; 0x00f9 ord
  VMM_Service _BlockOnID                               ; 0x00fa ord
  VMM_Service Schedule_Thread_Event                    ; 0x00fb ord
  VMM_Service Cancel_Thread_Event                      ; 0x00fc ord
  VMM_Service Set_Thread_Time_Out                      ; 0x00fd ord
  VMM_Service Set_Async_Time_Out                       ; 0x00fe ord
  VMM_Service _AllocateThreadDataSlot                  ; 0x00ff ord
  VMM_Service _FreeThreadDataSlot                      ; 0x0100 ord
  VMM_Service _CreateMutex                             ; 0x0101 ord
  VMM_Service _DestroyMutex                            ; 0x0102 ord
  VMM_Service _GetMutexOwner                           ; 0x0103 ord
  VMM_Service Call_When_Thread_Switched                ; 0x0104 ord
  VMM_Service VMMCreateThread                          ; 0x0105 ord
  VMM_Service _GetThreadExecTime                       ; 0x0106 ord
  VMM_Service VMMTerminateThread                       ; 0x0107 ord
  VMM_Service Get_Cur_Thread_Handle                    ; 0x0108 ord
  VMM_Service Test_Cur_Thread_Handle                   ; 0x0109 ord
  VMM_Service Get_Sys_Thread_Handle                    ; 0x010a ord
  VMM_Service Test_Sys_Thread_Handle                   ; 0x010b ord
  VMM_Service Validate_Thread_Handle                   ; 0x010c ord
  VMM_Service Get_Initial_Thread_Handle                ; 0x010d ord
  VMM_Service Test_Initial_Thread_Handle               ; 0x010e ord
  VMM_Service Debug_Test_Valid_Thread_Handle           ; 0x010f ord
  VMM_Service Debug_Test_Cur_Thread                    ; 0x0110 ord
  VMM_Service VMM_GetSystemInitState                   ; 0x0111 ord
  VMM_Service Cancel_Call_When_Thread_Switched         ; 0x0112 ord
  VMM_Service Get_Next_Thread_Handle                   ; 0x0113 ord
  VMM_Service Adjust_Thread_Exec_Priority              ; 0x0114 ord
  VMM_Service _Deallocate_Device_CB_Area               ; 0x0115 ord
  VMM_Service Remove_IO_Handler                        ; 0x0116 ord
  VMM_Service Remove_Mult_IO_Handlers                  ; 0x0117 ord
  VMM_Service Unhook_V86_Int_Chain                     ; 0x0118 ord
  VMM_Service Unhook_V86_Fault                         ; 0x0119 ord
  VMM_Service Unhook_PM_Fault                          ; 0x011a ord
  VMM_Service Unhook_VMM_Fault                         ; 0x011b ord
  VMM_Service Unhook_Device_Service                    ; 0x011c ord
  VMM_Service _PageReserve                             ; 0x011d ord
  VMM_Service _PageCommit                              ; 0x011e ord
  VMM_Service _PageDecommit                            ; 0x011f ord
  VMM_Service _PagerRegister                           ; 0x0120 ord
  VMM_Service _PagerQuery                              ; 0x0121 ord
  VMM_Service _PagerDeregister                         ; 0x0122 ord
  VMM_Service _ContextCreate                           ; 0x0123 ord
  VMM_Service _ContextDestroy                          ; 0x0124 ord
  VMM_Service _PageAttach                              ; 0x0125 ord
  VMM_Service _PageFlush                               ; 0x0126 ord
  VMM_Service _SignalID                                ; 0x0127 ord
  VMM_Service _PageCommitPhys                          ; 0x0128 ord
  VMM_Service _Register_Win32_Services                 ; 0x0129 ord
  VMM_Service Cancel_Call_When_Not_Critical            ; 0x012a ord
  VMM_Service Cancel_Call_When_Idle                    ; 0x012b ord
  VMM_Service Cancel_Call_When_Task_Switched           ; 0x012c ord
  VMM_Service _Debug_Printf_Service                    ; 0x012d ord
  VMM_Service _EnterMutex                              ; 0x012e ord
  VMM_Service _LeaveMutex                              ; 0x012f ord
  VMM_Service Simulate_VM_IO                           ; 0x0130 ord
  VMM_Service Signal_Semaphore_No_Switch               ; 0x0131 ord
  VMM_Service _ContextSwitch                           ; 0x0132 ord
  VMM_Service _PageModifyPermissions                   ; 0x0133 ord
  VMM_Service _PageQuery                               ; 0x0134 ord
  VMM_Service _EnterMustComplete                       ; 0x0135 ord
  VMM_Service _LeaveMustComplete                       ; 0x0136 ord
  VMM_Service _ResumeExecMustComplete                  ; 0x0137 ord
  VMM_Service _GetThreadTerminationStatus              ; 0x0138 ord
  VMM_Service _GetInstanceInfo                         ; 0x0139 ord
  VMM_Service _ExecIntMustComplete                     ; 0x013a ord
  VMM_Service _ExecVxDIntMustComplete                  ; 0x013b ord
  VMM_Service Begin_V86_Serialization                  ; 0x013c ord
  VMM_Service Unhook_V86_Page                          ; 0x013d ord
  VMM_Service VMM_GetVxDLocationList                   ; 0x013e ord
  VMM_Service VMM_GetDDBList                           ; 0x013f ord
  VMM_Service Unhook_NMI_Event                         ; 0x0140 ord
  VMM_Service Get_Instanced_V86_Int_Vector             ; 0x0141 ord
  VMM_Service Get_Set_Real_DOS_PSP                     ; 0x0142 ord
  VMM_Service Call_Priority_Thread_Event               ; 0x0143 ord
  VMM_Service Get_System_Time_Address                  ; 0x0144 ord
  VMM_Service Get_Crit_Status_Thread                   ; 0x0145 ord
  VMM_Service Get_DDB                                  ; 0x0146 ord
  VMM_Service Directed_Sys_Control                     ; 0x0147 ord
  VMM_Service _RegOpenKey                              ; 0x0148 ord
  VMM_Service _RegCloseKey                             ; 0x0149 ord
  VMM_Service _RegCreateKey                            ; 0x014a ord
  VMM_Service _RegDeleteKey                            ; 0x014b ord
  VMM_Service _RegEnumKey                              ; 0x014c ord
  VMM_Service _RegQueryValue                           ; 0x014d ord
  VMM_Service _RegSetValue                             ; 0x014e ord
  VMM_Service _RegDeleteValue                          ; 0x014f ord
  VMM_Service _RegEnumValue                            ; 0x0150 ord
  VMM_Service _RegQueryValueEx                         ; 0x0151 ord
  VMM_Service _RegSetValueEx                           ; 0x0152 ord
  VMM_Service _CallRing3                               ; 0x0153 ord
  VMM_Service Exec_PM_Int                              ; 0x0154 ord
  VMM_Service _RegFlushKey                             ; 0x0155 ord
  VMM_Service _PageCommitContig                        ; 0x0156 ord
  VMM_Service _GetCurrentContext                       ; 0x0157 ord
  VMM_Service _LocalizeSprintf                         ; 0x0158 ord
  VMM_Service _LocalizeStackSprintf                    ; 0x0159 ord
  VMM_Service Call_Restricted_Event                    ; 0x015a ord
  VMM_Service Cancel_Restricted_Event                  ; 0x015b ord
  VMM_Service Register_PEF_Provider                    ; 0x015c ord
  VMM_Service _GetPhysPageInfo                         ; 0x015d ord
  VMM_Service _RegQueryInfoKey                         ; 0x015e ord
  VMM_Service MemArb_Reserve_Pages                     ; 0x015f ord
  VMM_Service Time_Slice_Sys_VM_Idle                   ; 0x0160 ord
  VMM_Service Time_Slice_Sleep                         ; 0x0161 ord
  VMM_Service Boost_With_Decay                         ; 0x0162 ord
  VMM_Service Set_Inversion_Pri                        ; 0x0163 ord
  VMM_Service Reset_Inversion_Pri                      ; 0x0164 ord
  VMM_Service Release_Inversion_Pri                    ; 0x0165 ord
  VMM_Service Get_Thread_Win32_Pri                     ; 0x0166 ord
  VMM_Service Set_Thread_Win32_Pri                     ; 0x0167 ord
  VMM_Service Set_Thread_Static_Boost                  ; 0x0168 ord
  VMM_Service Set_VM_Static_Boost                      ; 0x0169 ord
  VMM_Service Release_Inversion_Pri_ID                 ; 0x016a ord
  VMM_Service Attach_Thread_To_Group                   ; 0x016b ord
  VMM_Service Detach_Thread_From_Group                 ; 0x016c ord
  VMM_Service Set_Group_Static_Boost                   ; 0x016d ord
  VMM_Service _GetRegistryPath                         ; 0x016e ord
  VMM_Service _GetRegistryKey                          ; 0x016f ord
  VMM_Service Cleanup_Thread_State                     ; 0x0170 ord
  VMM_Service _RegRemapPreDefKey                       ; 0x0171 ord
  VMM_Service End_V86_Serialization                    ; 0x0172 ord
  VMM_Service _Assert_Range                            ; 0x0173 ord
  VMM_Service _Sprintf                                 ; 0x0174 ord
  VMM_Service _PageChangePager                         ; 0x0175 ord
  VMM_Service _RegCreateDynKey                         ; 0x0176 ord
  VMM_Service _RegQueryMultipleValues                  ; 0x0177 ord
  VMM_Service Boost_Thread_With_VM                     ; 0x0178 ord
  VMM_Service Get_Boot_Flags                           ; 0x0179 ord
  VMM_Service Set_Boot_Flags                           ; 0x017a ord
  VMM_Service _lstrcpyn                                ; 0x017b ord
  VMM_Service _lstrlen                                 ; 0x017c ord
  VMM_Service _lmemcpy                                 ; 0x017d ord
  VMM_Service _GetVxDName                              ; 0x017e ord
  VMM_Service Force_Mutexes_Free                       ; 0x017f ord
  VMM_Service Restore_Forced_Mutexes                   ; 0x0180 ord
  VMM_Service _AddReclaimableItem                      ; 0x0181 ord
  VMM_Service _SetReclaimableItem                      ; 0x0182 ord
  VMM_Service _EnumReclaimableItem                     ; 0x0183 ord
  VMM_Service Time_Slice_Wake_Sys_VM                   ; 0x0184 ord
  VMM_Service VMM_Replace_Global_Environment           ; 0x0185 ord
  VMM_Service Begin_Non_Serial_Nest_V86_Exec           ; 0x0186 ord
  VMM_Service Get_Nest_Exec_Status                     ; 0x0187 ord
  VMM_Service Open_Boot_Log                            ; 0x0188 ord
  VMM_Service Write_Boot_Log                           ; 0x0189 ord
  VMM_Service Close_Boot_Log                           ; 0x018a ord
  VMM_Service EnableDisable_Boot_Log                   ; 0x018b ord
  VMM_Service _Call_On_My_Stack                        ; 0x018c ord
  VMM_Service Get_Inst_V86_Int_Vec_Base                ; 0x018d ord
  VMM_Service _lstrcmpi                                ; 0x018e ord
  VMM_Service _strupr                                  ; 0x018f ord
  VMM_Service Log_Fault_Call_Out                       ; 0x0190 ord
  VMM_Service _AtEventTime                             ; 0x0191 ord
End_Declare_VxD

Declare_VxD DEBUG, 0x0002
  DEBUG_Service DEBUG_Get_Version                        ; 0x0000 ord
  DEBUG_Service DEBUG_Fault                              ; 0x0001 ord
  DEBUG_Service DEBUG_CheckFault                         ; 0x0002 ord
  DEBUG_Service _DEBUG_LoadSyms                          ; 0x0003 ord
End_Declare_VxD

Declare_VxD VPICD, 0x0003
  VPICD_Service VPICD_Get_Version                        ; 0x0000 ord
  VPICD_Service VPICD_Virtualize_IRQ                     ; 0x0001 ord
  VPICD_Service VPICD_Set_Int_Request                    ; 0x0002 ord
  VPICD_Service VPICD_Clear_Int_Request                  ; 0x0003 ord
  VPICD_Service VPICD_Phys_EOI                           ; 0x0004 ord
  VPICD_Service VPICD_Get_Complete_Status                ; 0x0005 ord
  VPICD_Service VPICD_Get_Status                         ; 0x0006 ord
  VPICD_Service VPICD_Test_Phys_Request                  ; 0x0007 ord
  VPICD_Service VPICD_Physically_Mask                    ; 0x0008 ord
  VPICD_Service VPICD_Physically_Unmask                  ; 0x0009 ord
  VPICD_Service VPICD_Set_Auto_Masking                   ; 0x000a ord
  VPICD_Service VPICD_Get_IRQ_Complete_Status            ; 0x000b ord
  VPICD_Service VPICD_Convert_Handle_To_IRQ              ; 0x000c ord
  VPICD_Service VPICD_Convert_IRQ_To_Int                 ; 0x000d ord
  VPICD_Service VPICD_Convert_Int_To_IRQ                 ; 0x000e ord
  VPICD_Service VPICD_Call_When_Hw_Int                   ; 0x000f ord
  VPICD_Service VPICD_Force_Default_Owner                ; 0x0010 ord
  VPICD_Service VPICD_Force_Default_Behavior             ; 0x0011 ord
  VPICD_Service VPICD_Auto_Mask_At_Inst_Swap             ; 0x0012 ord
  VPICD_Service VPICD_Begin_Inst_Page_Swap               ; 0x0013 ord
  VPICD_Service VPICD_End_Inst_Page_Swap                 ; 0x0014 ord
  VPICD_Service VPICD_Virtual_EOI                        ; 0x0015 ord
  VPICD_Service VPICD_Get_Virtualization_Count           ; 0x0016 ord
  VPICD_Service VPICD_Post_Sys_Critical_Init             ; 0x0017 ord
  VPICD_Service VPICD_VM_SlavePIC_Mask_Change            ; 0x0018 ord
End_Declare_VxD

Declare_VxD VDMAD, 0x0004
  VDMAD_Service VDMAD_Get_Version                        ; 0x0000 ord
  VDMAD_Service VDMAD_Virtualize_Channel                 ; 0x0001 ord
  VDMAD_Service VDMAD_Get_Region_Info                    ; 0x0002 ord
  VDMAD_Service VDMAD_Set_Region_Info                    ; 0x0003 ord
  VDMAD_Service VDMAD_Get_Virt_State                     ; 0x0004 ord
  VDMAD_Service VDMAD_Set_Virt_State                     ; 0x0005 ord
  VDMAD_Service VDMAD_Set_Phys_State                     ; 0x0006 ord
  VDMAD_Service VDMAD_Mask_Channel                       ; 0x0007 ord
  VDMAD_Service VDMAD_UnMask_Channel                     ; 0x0008 ord
  VDMAD_Service VDMAD_Lock_DMA_Region                    ; 0x0009 ord
  VDMAD_Service VDMAD_Unlock_DMA_Region                  ; 0x000a ord
  VDMAD_Service VDMAD_Scatter_Lock                       ; 0x000b ord
  VDMAD_Service VDMAD_Scatter_Unlock                     ; 0x000c ord
  VDMAD_Service VDMAD_Reserve_Buffer_Space               ; 0x000d ord
  VDMAD_Service VDMAD_Request_Buffer                     ; 0x000e ord
  VDMAD_Service VDMAD_Release_Buffer                     ; 0x000f ord
  VDMAD_Service VDMAD_Copy_To_Buffer                     ; 0x0010 ord
  VDMAD_Service VDMAD_Copy_From_Buffer                   ; 0x0011 ord
  VDMAD_Service VDMAD_Default_Handler                    ; 0x0012 ord
  VDMAD_Service VDMAD_Disable_Translation                ; 0x0013 ord
  VDMAD_Service VDMAD_Enable_Translation                 ; 0x0014 ord
  VDMAD_Service VDMAD_Get_EISA_Adr_Mode                  ; 0x0015 ord
  VDMAD_Service VDMAD_Set_EISA_Adr_Mode                  ; 0x0016 ord
  VDMAD_Service VDMAD_Unlock_DMA_Region_No_Dirty         ; 0x0017 ord
  VDMAD_Service VDMAD_Phys_Mask_Channel                  ; 0x0018 ord
  VDMAD_Service VDMAD_Phys_Unmask_Channel                ; 0x0019 ord
  VDMAD_Service VDMAD_Unvirtualize_Channel               ; 0x001a ord
  VDMAD_Service VDMAD_Set_IO_Address                     ; 0x001b ord
  VDMAD_Service VDMAD_Get_Phys_Count                     ; 0x001c ord
  VDMAD_Service VDMAD_Get_Phys_Status                    ; 0x001d ord
  VDMAD_Service VDMAD_Get_Max_Phys_Page                  ; 0x001e ord
  VDMAD_Service VDMAD_Set_Channel_Callbacks              ; 0x001f ord
  VDMAD_Service VDMAD_Get_Virt_Count                     ; 0x0020 ord
  VDMAD_Service VDMAD_Set_Virt_Count                     ; 0x0021 ord
End_Declare_VxD

Declare_VxD VTD, 0x0005
  VTD_Service VTD_Get_Version                          ; 0x0000 ord
  VTD_Service VTD_Update_System_Clock                  ; 0x0001 ord
  VTD_Service VTD_Get_Interrupt_Period                 ; 0x0002 ord
  VTD_Service VTD_Begin_Min_Int_Period                 ; 0x0003 ord
  VTD_Service VTD_End_Min_Int_Period                   ; 0x0004 ord
  VTD_Service VTD_Disable_Trapping                     ; 0x0005 ord
  VTD_Service VTD_Enable_Trapping                      ; 0x0006 ord
  VTD_Service VTD_Get_Real_Time                        ; 0x0007 ord
  VTD_Service VTD_Get_Date_And_Time                    ; 0x0008 ord
  VTD_Service VTD_Adjust_VM_Count                      ; 0x0009 ord
  VTD_Service VTD_Delay                                ; 0x000a ord
End_Declare_VxD

Declare_VxD V86MMGR, 0x0006
  V86MMGR_Service V86MMGR_Get_Version                      ; 0x0000 ord
  V86MMGR_Service V86MMGR_Allocate_V86_Pages               ; 0x0001 ord
  V86MMGR_Service V86MMGR_Set_EMS_XMS_Limits               ; 0x0002 ord
  V86MMGR_Service V86MMGR_Get_EMS_XMS_Limits               ; 0x0003 ord
  V86MMGR_Service V86MMGR_Set_Mapping_Info                 ; 0x0004 ord
  V86MMGR_Service V86MMGR_Get_Mapping_Info                 ; 0x0005 ord
  V86MMGR_Service V86MMGR_Xlat_API                         ; 0x0006 ord
  V86MMGR_Service V86MMGR_Load_Client_Ptr                  ; 0x0007 ord
  V86MMGR_Service V86MMGR_Allocate_Buffer                  ; 0x0008 ord
  V86MMGR_Service V86MMGR_Free_Buffer                      ; 0x0009 ord
  V86MMGR_Service V86MMGR_Get_Xlat_Buff_State              ; 0x000a ord
  V86MMGR_Service V86MMGR_Set_Xlat_Buff_State              ; 0x000b ord
  V86MMGR_Service V86MMGR_Get_VM_Flat_Sel                  ; 0x000c ord
  V86MMGR_Service V86MMGR_Map_Pages                        ; 0x000d ord
  V86MMGR_Service V86MMGR_Free_Page_Map_Region             ; 0x000e ord
  V86MMGR_Service V86MMGR_LocalGlobalReg                   ; 0x000f ord
  V86MMGR_Service V86MMGR_GetPgStatus                      ; 0x0010 ord
  V86MMGR_Service V86MMGR_SetLocalA20                      ; 0x0011 ord
  V86MMGR_Service V86MMGR_ResetBasePages                   ; 0x0012 ord
  V86MMGR_Service V86MMGR_SetAvailMapPgs                   ; 0x0013 ord
  V86MMGR_Service V86MMGR_NoUMBInitCalls                   ; 0x0014 ord
  V86MMGR_Service V86MMGR_Get_EMS_XMS_Avail                ; 0x0015 ord
  V86MMGR_Service V86MMGR_Toggle_HMA                       ; 0x0016 ord
  V86MMGR_Service V86MMGR_Dev_Init                         ; 0x0017 ord
  V86MMGR_Service V86MMGR_Alloc_UM_Page                    ; 0x0018 ord
End_Declare_VxD

Declare_VxD PageSwap, 0x0007
  PageSwap_Service PageSwap_Get_Version                     ; 0x0000 ord
  PageSwap_Service PageSwap_Invalid_Service1                ; 0x0001 ord
  PageSwap_Service PageSwap_Invalid_Service2                ; 0x0002 ord
  PageSwap_Service PageSwap_Invalid_Service3                ; 0x0003 ord
  PageSwap_Service PageSwap_Invalid_Service4                ; 0x0004 ord
  PageSwap_Service PageSwap_Invalid_Service5                ; 0x0005 ord
  PageSwap_Service PageSwap_Test_IO_Valid                   ; 0x0006 ord
  PageSwap_Service PageSwap_Read_Or_Write                   ; 0x0007 ord
  PageSwap_Service PageSwap_Grow_File                       ; 0x0008 ord
  PageSwap_Service PageSwap_Init_File                       ; 0x0009 ord
End_Declare_VxD

Declare_VxD PARITY, 0x0008
End_Declare_VxD

Declare_VxD REBOOT, 0x0009
End_Declare_VxD

Declare_VxD VDD, 0x000a
  VDD_Service VDD_Get_Version                          ; 0x0000 ord
  VDD_Service VDD_PIF_State                            ; 0x0001 ord
  VDD_Service VDD_Get_GrabRtn                          ; 0x0002 ord
  VDD_Service VDD_Hide_Cursor                          ; 0x0003 ord
  VDD_Service VDD_Set_VMType                           ; 0x0004 ord
  VDD_Service VDD_Get_ModTime                          ; 0x0005 ord
  VDD_Service VDD_Set_HCurTrk                          ; 0x0006 ord
  VDD_Service VDD_Msg_ClrScrn                          ; 0x0007 ord
  VDD_Service VDD_Msg_ForColor                         ; 0x0008 ord
  VDD_Service VDD_Msg_BakColor                         ; 0x0009 ord
  VDD_Service VDD_Msg_TextOut                          ; 0x000a ord
  VDD_Service VDD_Msg_SetCursPos                       ; 0x000b ord
  VDD_Service VDD_Query_Access                         ; 0x000c ord
  VDD_Service VDD_Check_Update_Soon                    ; 0x000d ord
  VDD_Service VDD_Get_Mini_Dispatch_Table              ; 0x000e ord
  VDD_Service VDD_Register_Virtual_Port                ; 0x000f ord
  VDD_Service VDD_Get_VM_Info                          ; 0x0010 ord
  VDD_Service VDD_Get_Special_VM_IDs                   ; 0x0011 ord
  VDD_Service VDD_Register_Extra_Screen_Selector       ; 0x0012 ord
  VDD_Service VDD_Takeover_VGA_Port                    ; 0x0013 ord
  VDD_Service VDD_Get_DISPLAYINFO                      ; 0x0014 ord
  VDD_Service VDD_Do_Physical_IO                       ; 0x0015 ord
  VDD_Service VDD_Set_Sleep_Flag_Addr                  ; 0x0016 ord
End_Declare_VxD

Declare_VxD VSD, 0x000b
  VSD_Service VSD_Get_Version                          ; 0x0000 ord
  VSD_Service VSD_Bell                                 ; 0x0001 ord
  VSD_Service VSD_SoundOn                              ; 0x0002 ord
  VSD_Service VSD_TakeSoundPort                        ; 0x0003 ord
End_Declare_VxD

Declare_VxD VMD, 0x000c
  VMD_Service VMD_Get_Version                          ; 0x0000 ord
  VMD_Service VMD_Set_Mouse_Type                       ; 0x0001 ord
  VMD_Service VMD_Get_Mouse_Owner                      ; 0x0002 ord
End_Declare_VxD

Declare_VxD VKD, 0x000d
  VKD_Service VKD_Get_Version                          ; 0x0000 ord
  VKD_Service VKD_Define_Hot_Key                       ; 0x0001 ord
  VKD_Service VKD_Remove_Hot_Key                       ; 0x0002 ord
  VKD_Service VKD_Local_Enable_Hot_Key                 ; 0x0003 ord
  VKD_Service VKD_Local_Disable_Hot_Key                ; 0x0004 ord
  VKD_Service VKD_Reflect_Hot_Key                      ; 0x0005 ord
  VKD_Service VKD_Cancel_Hot_Key_State                 ; 0x0006 ord
  VKD_Service VKD_Force_Keys                           ; 0x0007 ord
  VKD_Service VKD_Get_Kbd_Owner                        ; 0x0008 ord
  VKD_Service VKD_Define_Paste_Mode                    ; 0x0009 ord
  VKD_Service VKD_Start_Paste                          ; 0x000a ord
  VKD_Service VKD_Cancel_Paste                         ; 0x000b ord
  VKD_Service VKD_Get_Msg_Key                          ; 0x000c ord
  VKD_Service VKD_Peek_Msg_Key                         ; 0x000d ord
  VKD_Service VKD_Flush_Msg_Key_Queue                  ; 0x000e ord
  VKD_Service VKD_Enable_Keyboard                      ; 0x000f ord
  VKD_Service VKD_Disable_Keyboard                     ; 0x0010 ord
  VKD_Service VKD_Get_Shift_State                      ; 0x0011 ord
  VKD_Service VKD_Filter_Keyboard_Input                ; 0x0012 ord
  VKD_Service VKD_Put_Byte                             ; 0x0013 ord
  VKD_Service VKD_Set_Shift_State                      ; 0x0014 ord
End_Declare_VxD

Declare_VxD VCD, 0x000e
  VCD_Service VCD_Get_Version                          ; 0x0000 ord
  VCD_Service VCD_Set_Port_Global                      ; 0x0001 ord
  VCD_Service VCD_Get_Focus                            ; 0x0002 ord
  VCD_Service VCD_Virtualize_Port                      ; 0x0003 ord
  VCD_Service VCD_Acquire_Port                         ; 0x0004 ord
  VCD_Service VCD_Free_Port                            ; 0x0005 ord
  VCD_Service VCD_Acquire_Port_Windows_Style           ; 0x0006 ord
  VCD_Service VCD_Free_Port_Windows_Style              ; 0x0007 ord
  VCD_Service VCD_Steal_Port_Windows_Style             ; 0x0008 ord
  VCD_Service VCD_Find_COM_Index                       ; 0x0009 ord
  VCD_Service VCD_Set_Port_Global_Special              ; 0x000a ord
  VCD_Service VCD_Virtualize_Port_Dynamic              ; 0x000b ord
  VCD_Service VCD_Unvirtualize_Port_Dynamic            ; 0x000c ord
End_Declare_VxD

Declare_VxD VPD, 0x000f
End_Declare_VxD

Declare_VxD BlockDev, 0x0010
  BlockDev_Service BlockDev_Get_Version                     ; 0x0000 ord
  BlockDev_Service BlockDev_Register_Device                 ; 0x0001 ord
  BlockDev_Service BlockDev_Find_Int13_Drive                ; 0x0002 ord
  BlockDev_Service BlockDev_Get_Device_List                 ; 0x0003 ord
  BlockDev_Service BlockDev_Send_Command                    ; 0x0004 ord
  BlockDev_Service BlockDev_Command_Complete                ; 0x0005 ord
  BlockDev_Service BlockDev_Synchronous_Command             ; 0x0006 ord
End_Declare_VxD

Declare_VxD VMCPD, 0x0011
  VMCPD_Service VMCPD_Get_Version                        ; 0x0000 ord
  VMCPD_Service VMCPD_Get_Virt_State                     ; 0x0001 ord
  VMCPD_Service VMCPD_Set_Virt_State                     ; 0x0002 ord
  VMCPD_Service VMCPD_Get_CR0_State                      ; 0x0003 ord
  VMCPD_Service VMCPD_Set_CR0_State                      ; 0x0004 ord
  VMCPD_Service VMCPD_Get_Thread_State                   ; 0x0005 ord
  VMCPD_Service VMCPD_Set_Thread_State                   ; 0x0006 ord
  VMCPD_Service _VMCPD_Get_FP_Instruction_Size           ; 0x0007 ord
  VMCPD_Service VMCPD_Set_Thread_Precision               ; 0x0008 ord
End_Declare_VxD

Declare_VxD EBIOS, 0x0012
  EBIOS_Service EBIOS_Get_Version                        ; 0x0000 ord
  EBIOS_Service EBIOS_Get_Unused_Mem                     ; 0x0001 ord
End_Declare_VxD

Declare_VxD BIOSXLAT, 0x0013
End_Declare_VxD

Declare_VxD VNETBIOS, 0x0014
  VNETBIOS_Service VNETBIOS_Get_Version                     ; 0x0000 ord
  VNETBIOS_Service VNETBIOS_Register                        ; 0x0001 ord
  VNETBIOS_Service VNETBIOS_Submit                          ; 0x0002 ord
  VNETBIOS_Service VNETBIOS_Enum                            ; 0x0003 ord
  VNETBIOS_Service VNETBIOS_Deregister                      ; 0x0004 ord
  VNETBIOS_Service VNETBIOS_Register2                       ; 0x0005 ord
  VNETBIOS_Service VNETBIOS_Map                             ; 0x0006 ord
  VNETBIOS_Service VNETBIOS_Enum2                           ; 0x0007 ord
End_Declare_VxD

Declare_VxD DOSMGR, 0x0015
  DOSMGR_Service DOSMGR_Get_Version                       ; 0x0000 ord
  DOSMGR_Service _DOSMGR_Set_Exec_VM_Data                 ; 0x0001 ord
  DOSMGR_Service DOSMGR_Copy_VM_Drive_State               ; 0x0002 ord
  DOSMGR_Service _DOSMGR_Exec_VM                          ; 0x0003 ord
  DOSMGR_Service DOSMGR_Get_IndosPtr                      ; 0x0004 ord
  DOSMGR_Service DOSMGR_Add_Device                        ; 0x0005 ord
  DOSMGR_Service DOSMGR_Remove_Device                     ; 0x0006 ord
  DOSMGR_Service DOSMGR_Instance_Device                   ; 0x0007 ord
  DOSMGR_Service DOSMGR_Get_DOS_Crit_Status               ; 0x0008 ord
  DOSMGR_Service DOSMGR_Enable_Indos_Polling              ; 0x0009 ord
  DOSMGR_Service DOSMGR_BackFill_Allowed                  ; 0x000a ord
  DOSMGR_Service DOSMGR_LocalGlobalReg                    ; 0x000b ord
  DOSMGR_Service DOSMGR_Init_UMB_Area                     ; 0x000c ord
  DOSMGR_Service DOSMGR_Begin_V86_App                     ; 0x000d ord
  DOSMGR_Service DOSMGR_End_V86_App                       ; 0x000e ord
  DOSMGR_Service DOSMGR_Alloc_Local_Sys_VM_Mem            ; 0x000f ord
  DOSMGR_Service DOSMGR_Grow_CDSs                         ; 0x0010 ord
  DOSMGR_Service DOSMGR_Translate_Server_DOS_Call         ; 0x0011 ord
  DOSMGR_Service DOSMGR_MMGR_PSP_Change_Notifier          ; 0x0012 ord
End_Declare_VxD

Declare_VxD WINLOAD, 0x0016
End_Declare_VxD

Declare_VxD SHELL, 0x0017
  SHELL_Service SHELL_Get_Version                        ; 0x0000 ord
  SHELL_Service SHELL_Resolve_Contention                 ; 0x0001 ord
  SHELL_Service SHELL_Event                              ; 0x0002 ord
  SHELL_Service SHELL_SYSMODAL_Message                   ; 0x0003 ord
  SHELL_Service SHELL_Message                            ; 0x0004 ord
  SHELL_Service SHELL_GetVMInfo                          ; 0x0005 ord
  SHELL_Service _SHELL_PostMessage                       ; 0x0006 ord
  SHELL_Service _SHELL_ShellExecute                      ; 0x0007 ord
  SHELL_Service _SHELL_PostShellMessage                  ; 0x0008 ord
  SHELL_Service SHELL_DispatchRing0AppyEvents            ; 0x0009 ord
  SHELL_Service SHELL_Hook_Properties                    ; 0x000a ord
  SHELL_Service SHELL_Unhook_Properties                  ; 0x000b ord
  SHELL_Service SHELL_Update_User_Activity               ; 0x000c ord
  SHELL_Service _SHELL_QueryAppyTimeAvailable            ; 0x000d ord
  SHELL_Service _SHELL_CallAtAppyTime                    ; 0x000e ord
  SHELL_Service _SHELL_CancelAppyTimeEvent               ; 0x000f ord
  SHELL_Service _SHELL_BroadcastSystemMessage            ; 0x0010 ord
  SHELL_Service _SHELL_HookSystemBroadcast               ; 0x0011 ord
  SHELL_Service _SHELL_UnhookSystemBroadcast             ; 0x0012 ord
  SHELL_Service _SHELL_LocalAllocEx                      ; 0x0013 ord
  SHELL_Service _SHELL_LocalFree                         ; 0x0014 ord
  SHELL_Service _SHELL_LoadLibrary                       ; 0x0015 ord
  SHELL_Service _SHELL_FreeLibrary                       ; 0x0016 ord
  SHELL_Service _SHELL_GetProcAddress                    ; 0x0017 ord
  SHELL_Service _SHELL_CallDll                           ; 0x0018 ord
  SHELL_Service _SHELL_SuggestSingleMSDOSMode            ; 0x0019 ord
  SHELL_Service SHELL_CheckHotkeyAllowed                 ; 0x001a ord
  SHELL_Service _SHELL_GetDOSAppInfo                     ; 0x001b ord
End_Declare_VxD

Declare_VxD VMPoll, 0x0018
  VMPoll_Service VMPoll_Get_Version                       ; 0x0000 ord
  VMPoll_Service VMPoll_Enable_Disable                    ; 0x0001 ord
  VMPoll_Service VMPoll_Reset_Detection                   ; 0x0002 ord
  VMPoll_Service VMPoll_Check_Idle                        ; 0x0003 ord
End_Declare_VxD

Declare_VxD VPROD, 0x0019
End_Declare_VxD

Declare_VxD DOSNET, 0x001a
  DOSNET_Service DOSNET_Get_Version                       ; 0x0000 ord
  DOSNET_Service DOSNET_Send_FILESYSCHANGE                ; 0x0001 ord
  DOSNET_Service DOSNET_Do_PSP_Adjust                     ; 0x0002 ord
End_Declare_VxD

Declare_VxD VFD, 0x001b
  VFD_Service VFD_Get_Version                          ; 0x0000 ord
End_Declare_VxD

Declare_VxD VDD2, 0x001c
  VDD2_Service VDD2_Get_Version                         ; 0x0000 ord
End_Declare_VxD

Declare_VxD WINDEBUG, 0x001d
End_Declare_VxD

Declare_VxD TSRLOAD, 0x001e
End_Declare_VxD

Declare_VxD BIOSHOOK, 0x001f
End_Declare_VxD

Declare_VxD Int13, 0x0020
  Int13_Service Int13_Get_Version                        ; 0x0000 ord
  Int13_Service Int13_Device_Registered                  ; 0x0001 ord
  Int13_Service Int13_Translate_VM_Int                   ; 0x0002 ord
  Int13_Service Int13_Hooking_BIOS_Int                   ; 0x0003 ord
  Int13_Service Int13_Unhooking_BIOS_Int                 ; 0x0004 ord
End_Declare_VxD

Declare_VxD PageFile, 0x0021
  PageFile_Service PageFile_Get_Version                     ; 0x0000 ord
  PageFile_Service PageFile_Init_File                       ; 0x0001 ord
  PageFile_Service PageFile_Clean_Up                        ; 0x0002 ord
  PageFile_Service PageFile_Grow_File                       ; 0x0003 ord
  PageFile_Service PageFile_Read_Or_Write                   ; 0x0004 ord
  PageFile_Service PageFile_Cancel                          ; 0x0005 ord
  PageFile_Service PageFile_Test_IO_Valid                   ; 0x0006 ord
  PageFile_Service PageFile_Get_Size_Info                   ; 0x0007 ord
  PageFile_Service PageFile_Set_Async_Manager               ; 0x0008 ord
  PageFile_Service PageFile_Call_Async_Manager              ; 0x0009 ord
End_Declare_VxD

Declare_VxD SCSI, 0x0022
End_Declare_VxD

Declare_VxD SCSIFD, 0x0024
End_Declare_VxD

Declare_VxD VPEND, 0x0025
End_Declare_VxD

Declare_VxD APM, 0x0026
End_Declare_VxD

Declare_VxD VXDLDR, 0x0027
  VXDLDR_Service VXDLDR_GetVersion                        ; 0x0000 ord
  VXDLDR_Service VXDLDR_LoadDevice                        ; 0x0001 ord
  VXDLDR_Service VXDLDR_UnloadDevice                      ; 0x0002 ord
  VXDLDR_Service VXDLDR_DevInitSucceeded                  ; 0x0003 ord
  VXDLDR_Service VXDLDR_DevInitFailed                     ; 0x0004 ord
  VXDLDR_Service VXDLDR_GetDeviceList                     ; 0x0005 ord
  VXDLDR_Service VXDLDR_UnloadMe                          ; 0x0006 ord
  VXDLDR_Service _PELDR_LoadModule                        ; 0x0007 ord
  VXDLDR_Service _PELDR_GetModuleHandle                   ; 0x0008 ord
  VXDLDR_Service _PELDR_GetModuleUsage                    ; 0x0009 ord
  VXDLDR_Service _PELDR_GetEntryPoint                     ; 0x000a ord
  VXDLDR_Service _PELDR_GetProcAddress                    ; 0x000b ord
  VXDLDR_Service _PELDR_AddExportTable                    ; 0x000c ord
  VXDLDR_Service _PELDR_RemoveExportTable                 ; 0x000d ord
  VXDLDR_Service _PELDR_FreeModule                        ; 0x000e ord
  VXDLDR_Service VXDLDR_Notify                            ; 0x000f ord
  VXDLDR_Service _PELDR_InitCompleted                     ; 0x0010 ord
  VXDLDR_Service _PELDR_LoadModuleEx                      ; 0x0011 ord
End_Declare_VxD

Declare_VxD NDIS, 0x0028
End_Declare_VxD

Declare_VxD VWIN32, 0x002a
  VWIN32_Service VWIN32_Get_Version                       ; 0x0000 ord
  VWIN32_Service VWIN32_DIOCCompletionRoutine             ; 0x0001 ord
  VWIN32_Service _VWIN32_QueueUserApc                     ; 0x0002 ord
  VWIN32_Service _VWIN32_Get_Thread_Context               ; 0x0003 ord
  VWIN32_Service _VWIN32_Set_Thread_Context               ; 0x0004 ord
  VWIN32_Service _VWIN32_CopyMem                          ; 0x0005 ord
  VWIN32_Service _VWIN32_Npx_Exception                    ; 0x0006 ord
  VWIN32_Service _VWIN32_Emulate_Npx                      ; 0x0007 ord
  VWIN32_Service _VWIN32_CheckDelayedNpxTrap              ; 0x0008 ord
  VWIN32_Service VWIN32_EnterCrstR0                       ; 0x0009 ord
  VWIN32_Service VWIN32_LeaveCrstR0                       ; 0x000a ord
  VWIN32_Service _VWIN32_FaultPopup                       ; 0x000b ord
  VWIN32_Service VWIN32_GetContextHandle                  ; 0x000c ord
  VWIN32_Service VWIN32_GetCurrentProcessHandle           ; 0x000d ord
  VWIN32_Service _VWIN32_SetWin32Event                    ; 0x000e ord
  VWIN32_Service _VWIN32_PulseWin32Event                  ; 0x000f ord
  VWIN32_Service _VWIN32_ResetWin32Event                  ; 0x0010 ord
  VWIN32_Service _VWIN32_WaitSingleObject                 ; 0x0011 ord
  VWIN32_Service _VWIN32_WaitMultipleObjects              ; 0x0012 ord
  VWIN32_Service _VWIN32_CreateRing0Thread                ; 0x0013 ord
  VWIN32_Service _VWIN32_CloseVxDHandle                   ; 0x0014 ord
  VWIN32_Service VWIN32_ActiveTimeBiasSet                 ; 0x0015 ord
  VWIN32_Service VWIN32_GetCurrentDirectory               ; 0x0016 ord
  VWIN32_Service VWIN32_BlueScreenPopup                   ; 0x0017 ord
  VWIN32_Service VWIN32_TerminateApp                      ; 0x0018 ord
  VWIN32_Service _VWIN32_QueueKernelAPC                   ; 0x0019 ord
  VWIN32_Service VWIN32_SysErrorBox                       ; 0x001a ord
  VWIN32_Service _VWIN32_IsClientWin32                    ; 0x001b ord
  VWIN32_Service VWIN32_IFSRIPWhenLev2Taken               ; 0x001c ord
End_Declare_VxD

Declare_VxD VCOMM, 0x002b
  VCOMM_Service VCOMM_Get_Version                        ; 0x0000 ord
  VCOMM_Service _VCOMM_Register_Port_Driver              ; 0x0001 ord
  VCOMM_Service _VCOMM_Acquire_Port                      ; 0x0002 ord
  VCOMM_Service _VCOMM_Release_Port                      ; 0x0003 ord
  VCOMM_Service _VCOMM_OpenComm                          ; 0x0004 ord
  VCOMM_Service _VCOMM_SetCommState                      ; 0x0005 ord
  VCOMM_Service _VCOMM_GetCommState                      ; 0x0006 ord
  VCOMM_Service _VCOMM_SetupComm                         ; 0x0007 ord
  VCOMM_Service _VCOMM_TransmitCommChar                  ; 0x0008 ord
  VCOMM_Service _VCOMM_CloseComm                         ; 0x0009 ord
  VCOMM_Service _VCOMM_GetCommQueueStatus                ; 0x000a ord
  VCOMM_Service _VCOMM_ClearCommError                    ; 0x000b ord
  VCOMM_Service _VCOMM_GetModemStatus                    ; 0x000c ord
  VCOMM_Service _VCOMM_GetCommProperties                 ; 0x000d ord
  VCOMM_Service _VCOMM_EscapeCommFunction                ; 0x000e ord
  VCOMM_Service _VCOMM_PurgeComm                         ; 0x000f ord
  VCOMM_Service _VCOMM_SetCommEventMask                  ; 0x0010 ord
  VCOMM_Service _VCOMM_GetCommEventMask                  ; 0x0011 ord
  VCOMM_Service _VCOMM_WriteComm                         ; 0x0012 ord
  VCOMM_Service _VCOMM_ReadComm                          ; 0x0013 ord
  VCOMM_Service _VCOMM_EnableCommNotification            ; 0x0014 ord
  VCOMM_Service _VCOMM_GetLastError                      ; 0x0015 ord
  VCOMM_Service _VCOMM_Steal_Port                        ; 0x0016 ord
  VCOMM_Service _VCOMM_SetReadCallBack                   ; 0x0017 ord
  VCOMM_Service _VCOMM_SetWriteCallBack                  ; 0x0018 ord
  VCOMM_Service _VCOMM_Add_Port                          ; 0x0019 ord
  VCOMM_Service _VCOMM_GetSetCommTimeouts                ; 0x001a ord
  VCOMM_Service _VCOMM_SetWriteRequest                   ; 0x001b ord
  VCOMM_Service _VCOMM_SetReadRequest                    ; 0x001c ord
  VCOMM_Service _VCOMM_Dequeue_Request                   ; 0x001d ord
  VCOMM_Service _VCOMM_Enumerate_DevNodes                ; 0x001e ord
  VCOMM_Service VCOMM_Map_Win32DCB_To_Ring0              ; 0x001f ord
  VCOMM_Service VCOMM_Map_Ring0DCB_To_Win32              ; 0x0020 ord
  VCOMM_Service _VCOMM_Get_Contention_Handler            ; 0x0021 ord
  VCOMM_Service _VCOMM_Map_Name_To_Resource              ; 0x0022 ord
End_Declare_VxD

Declare_VxD SPOOLER, 0x002c
End_Declare_VxD

Declare_VxD WIN32S, 0x002d
End_Declare_VxD

Declare_VxD DEBUGCMD, 0x002e
End_Declare_VxD

Declare_VxD CONFIGMG, 0x0033
  CONFIGMG_Service _CONFIGMG_Get_Version                    ; 0x0000 ord
  CONFIGMG_Service _CONFIGMG_Initialize                     ; 0x0001 ord
  CONFIGMG_Service _CONFIGMG_Locate_DevNode                 ; 0x0002 ord
  CONFIGMG_Service _CONFIGMG_Get_Parent                     ; 0x0003 ord
  CONFIGMG_Service _CONFIGMG_Get_Child                      ; 0x0004 ord
  CONFIGMG_Service _CONFIGMG_Get_Sibling                    ; 0x0005 ord
  CONFIGMG_Service _CONFIGMG_Get_Device_ID_Size             ; 0x0006 ord
  CONFIGMG_Service _CONFIGMG_Get_Device_ID                  ; 0x0007 ord
  CONFIGMG_Service _CONFIGMG_Get_Depth                      ; 0x0008 ord
  CONFIGMG_Service _CONFIGMG_Get_Private_DWord              ; 0x0009 ord
  CONFIGMG_Service _CONFIGMG_Set_Private_DWord              ; 0x000a ord
  CONFIGMG_Service _CONFIGMG_Create_DevNode                 ; 0x000b ord
  CONFIGMG_Service _CONFIGMG_Query_Remove_SubTree           ; 0x000c ord
  CONFIGMG_Service _CONFIGMG_Remove_SubTree                 ; 0x000d ord
  CONFIGMG_Service _CONFIGMG_Register_Device_Driver         ; 0x000e ord
  CONFIGMG_Service _CONFIGMG_Register_Enumerator            ; 0x000f ord
  CONFIGMG_Service _CONFIGMG_Register_Arbitrator            ; 0x0010 ord
  CONFIGMG_Service _CONFIGMG_Deregister_Arbitrator          ; 0x0011 ord
  CONFIGMG_Service _CONFIGMG_Query_Arbitrator_Free_Size     ; 0x0012 ord
  CONFIGMG_Service _CONFIGMG_Query_Arbitrator_Free_Data     ; 0x0013 ord
  CONFIGMG_Service _CONFIGMG_Sort_NodeList                  ; 0x0014 ord
  CONFIGMG_Service _CONFIGMG_Yield                          ; 0x0015 ord
  CONFIGMG_Service _CONFIGMG_Lock                           ; 0x0016 ord
  CONFIGMG_Service _CONFIGMG_Unlock                         ; 0x0017 ord
  CONFIGMG_Service _CONFIGMG_Add_Empty_Log_Conf             ; 0x0018 ord
  CONFIGMG_Service _CONFIGMG_Free_Log_Conf                  ; 0x0019 ord
  CONFIGMG_Service _CONFIGMG_Get_First_Log_Conf             ; 0x001a ord
  CONFIGMG_Service _CONFIGMG_Get_Next_Log_Conf              ; 0x001b ord
  CONFIGMG_Service _CONFIGMG_Add_Res_Des                    ; 0x001c ord
  CONFIGMG_Service _CONFIGMG_Modify_Res_Des                 ; 0x001d ord
  CONFIGMG_Service _CONFIGMG_Free_Res_Des                   ; 0x001e ord
  CONFIGMG_Service _CONFIGMG_Get_Next_Res_Des               ; 0x001f ord
  CONFIGMG_Service _CONFIGMG_Get_Performance_Info           ; 0x0020 ord
  CONFIGMG_Service _CONFIGMG_Get_Res_Des_Data_Size          ; 0x0021 ord
  CONFIGMG_Service _CONFIGMG_Get_Res_Des_Data               ; 0x0022 ord
  CONFIGMG_Service _CONFIGMG_Process_Events_Now             ; 0x0023 ord
  CONFIGMG_Service _CONFIGMG_Create_Range_List              ; 0x0024 ord
  CONFIGMG_Service _CONFIGMG_Add_Range                      ; 0x0025 ord
  CONFIGMG_Service _CONFIGMG_Delete_Range                   ; 0x0026 ord
  CONFIGMG_Service _CONFIGMG_Test_Range_Available           ; 0x0027 ord
  CONFIGMG_Service _CONFIGMG_Dup_Range_List                 ; 0x0028 ord
  CONFIGMG_Service _CONFIGMG_Free_Range_List                ; 0x0029 ord
  CONFIGMG_Service _CONFIGMG_Invert_Range_List              ; 0x002a ord
  CONFIGMG_Service _CONFIGMG_Intersect_Range_List           ; 0x002b ord
  CONFIGMG_Service _CONFIGMG_First_Range                    ; 0x002c ord
  CONFIGMG_Service _CONFIGMG_Next_Range                     ; 0x002d ord
  CONFIGMG_Service _CONFIGMG_Dump_Range_List                ; 0x002e ord
  CONFIGMG_Service _CONFIGMG_Load_DLVxDs                    ; 0x002f ord
  CONFIGMG_Service _CONFIGMG_Get_DDBs                       ; 0x0030 ord
  CONFIGMG_Service _CONFIGMG_Get_CRC_CheckSum               ; 0x0031 ord
  CONFIGMG_Service _CONFIGMG_Register_DevLoader             ; 0x0032 ord
  CONFIGMG_Service _CONFIGMG_Reenumerate_DevNode            ; 0x0033 ord
  CONFIGMG_Service _CONFIGMG_Setup_DevNode                  ; 0x0034 ord
  CONFIGMG_Service _CONFIGMG_Reset_Children_Marks           ; 0x0035 ord
  CONFIGMG_Service _CONFIGMG_Get_DevNode_Status             ; 0x0036 ord
  CONFIGMG_Service _CONFIGMG_Remove_Unmarked_Children       ; 0x0037 ord
  CONFIGMG_Service _CONFIGMG_ISAPNP_To_CM                   ; 0x0038 ord
  CONFIGMG_Service _CONFIGMG_CallBack_Device_Driver         ; 0x0039 ord
  CONFIGMG_Service _CONFIGMG_CallBack_Enumerator            ; 0x003a ord
  CONFIGMG_Service _CONFIGMG_Get_Alloc_Log_Conf             ; 0x003b ord
  CONFIGMG_Service _CONFIGMG_Get_DevNode_Key_Size           ; 0x003c ord
  CONFIGMG_Service _CONFIGMG_Get_DevNode_Key                ; 0x003d ord
  CONFIGMG_Service _CONFIGMG_Read_Registry_Value            ; 0x003e ord
  CONFIGMG_Service _CONFIGMG_Write_Registry_Value           ; 0x003f ord
  CONFIGMG_Service _CONFIGMG_Disable_DevNode                ; 0x0040 ord
  CONFIGMG_Service _CONFIGMG_Enable_DevNode                 ; 0x0041 ord
  CONFIGMG_Service _CONFIGMG_Move_DevNode                   ; 0x0042 ord
  CONFIGMG_Service _CONFIGMG_Set_Bus_Info                   ; 0x0043 ord
  CONFIGMG_Service _CONFIGMG_Get_Bus_Info                   ; 0x0044 ord
  CONFIGMG_Service _CONFIGMG_Set_HW_Prof                    ; 0x0045 ord
  CONFIGMG_Service _CONFIGMG_Recompute_HW_Prof              ; 0x0046 ord
  CONFIGMG_Service _CONFIGMG_Query_Change_HW_Prof           ; 0x0047 ord
  CONFIGMG_Service _CONFIGMG_Get_Device_Driver_Private_DWord ; 0x0048 ord
  CONFIGMG_Service _CONFIGMG_Set_Device_Driver_Private_DWord ; 0x0049 ord
  CONFIGMG_Service _CONFIGMG_Get_HW_Prof_Flags              ; 0x004a ord
  CONFIGMG_Service _CONFIGMG_Set_HW_Prof_Flags              ; 0x004b ord
  CONFIGMG_Service _CONFIGMG_Read_Registry_Log_Confs        ; 0x004c ord
  CONFIGMG_Service _CONFIGMG_Run_Detection                  ; 0x004d ord
  CONFIGMG_Service _CONFIGMG_Call_At_Appy_Time              ; 0x004e ord
  CONFIGMG_Service _CONFIGMG_Fail_Change_HW_Prof            ; 0x004f ord
  CONFIGMG_Service _CONFIGMG_Set_Private_Problem            ; 0x0050 ord
  CONFIGMG_Service _CONFIGMG_Debug_DevNode                  ; 0x0051 ord
  CONFIGMG_Service _CONFIGMG_Get_Hardware_Profile_Info      ; 0x0052 ord
  CONFIGMG_Service _CONFIGMG_Register_Enumerator_Function   ; 0x0053 ord
  CONFIGMG_Service _CONFIGMG_Call_Enumerator_Function       ; 0x0054 ord
  CONFIGMG_Service _CONFIGMG_Add_ID                         ; 0x0055 ord
  CONFIGMG_Service _CONFIGMG_Find_Range                     ; 0x0056 ord
  CONFIGMG_Service _CONFIGMG_Get_Global_State               ; 0x0057 ord
  CONFIGMG_Service _CONFIGMG_Broadcast_Device_Change_Message ; 0x0058 ord
  CONFIGMG_Service _CONFIGMG_Call_DevNode_Handler           ; 0x0059 ord
  CONFIGMG_Service _CONFIGMG_Remove_Reinsert_All            ; 0x005a ord
End_Declare_VxD

Declare_VxD DWCFGMG, 0x0034
End_Declare_VxD

Declare_VxD SCSIPORT, 0x0035
End_Declare_VxD

Declare_VxD VFBACKUP, 0x0036
  VFBACKUP_Service VFBACKUP_Get_Version                     ; 0x0000 ord
  VFBACKUP_Service VFBACKUP_Lock_NEC                        ; 0x0001 ord
  VFBACKUP_Service VFBACKUP_UnLock_NEC                      ; 0x0002 ord
  VFBACKUP_Service VFBACKUP_Register_NEC                    ; 0x0003 ord
  VFBACKUP_Service VFBACKUP_Register_VFD                    ; 0x0004 ord
  VFBACKUP_Service VFBACKUP_Lock_All_Ports                  ; 0x0005 ord
End_Declare_VxD

Declare_VxD ENABLE, 0x0037
  ENABLE_Service VMINI_GetVersion                         ; 0x0000 ord
  ENABLE_Service VMINI_Update                             ; 0x0001 ord
  ENABLE_Service VMINI_Status                             ; 0x0002 ord
  ENABLE_Service VMINI_DisplayError                       ; 0x0003 ord
  ENABLE_Service VMINI_SetTimeStamp                       ; 0x0004 ord
  ENABLE_Service VMINI_Siren                              ; 0x0005 ord
  ENABLE_Service VMINI_RegisterAccess                     ; 0x0006 ord
  ENABLE_Service VMINI_GetData                            ; 0x0007 ord
  ENABLE_Service VMINI_ShutDownItem                       ; 0x0008 ord
  ENABLE_Service VMINI_RegisterSK                         ; 0x0009 ord
End_Declare_VxD

Declare_VxD VCOND, 0x0038
  VCOND_Service VCOND_Get_Version                        ; 0x0000 ord
  VCOND_Service VCOND_Launch_ConApp_Inherited            ; 0x0001 ord
End_Declare_VxD

Declare_VxD ISAPNP, 0x003c
End_Declare_VxD

Declare_VxD BIOS, 0x003d
End_Declare_VxD

Declare_VxD IFSMgr, 0x0040
  IFSMgr_Service IFSMgr_Get_Version                       ; 0x0000 ord
  IFSMgr_Service IFSMgr_RegisterMount                     ; 0x0001 ord
  IFSMgr_Service IFSMgr_RegisterNet                       ; 0x0002 ord
  IFSMgr_Service IFSMgr_RegisterMailSlot                  ; 0x0003 ord
  IFSMgr_Service IFSMgr_Attach                            ; 0x0004 ord
  IFSMgr_Service IFSMgr_Detach                            ; 0x0005 ord
  IFSMgr_Service IFSMgr_Get_NetTime                       ; 0x0006 ord
  IFSMgr_Service IFSMgr_Get_DOSTime                       ; 0x0007 ord
  IFSMgr_Service IFSMgr_SetupConnection                   ; 0x0008 ord
  IFSMgr_Service IFSMgr_DerefConnection                   ; 0x0009 ord
  IFSMgr_Service IFSMgr_ServerDOSCall                     ; 0x000a ord
  IFSMgr_Service IFSMgr_CompleteAsync                     ; 0x000b ord
  IFSMgr_Service IFSMgr_RegisterHeap                      ; 0x000c ord
  IFSMgr_Service IFSMgr_GetHeap                           ; 0x000d ord
  IFSMgr_Service IFSMgr_RetHeap                           ; 0x000e ord
  IFSMgr_Service IFSMgr_CheckHeap                         ; 0x000f ord
  IFSMgr_Service IFSMgr_CheckHeapItem                     ; 0x0010 ord
  IFSMgr_Service IFSMgr_FillHeapSpare                     ; 0x0011 ord
  IFSMgr_Service IFSMgr_Block                             ; 0x0012 ord
  IFSMgr_Service IFSMgr_Wakeup                            ; 0x0013 ord
  IFSMgr_Service IFSMgr_Yield                             ; 0x0014 ord
  IFSMgr_Service IFSMgr_SchedEvent                        ; 0x0015 ord
  IFSMgr_Service IFSMgr_QueueEvent                        ; 0x0016 ord
  IFSMgr_Service IFSMgr_KillEvent                         ; 0x0017 ord
  IFSMgr_Service IFSMgr_FreeIOReq                         ; 0x0018 ord
  IFSMgr_Service IFSMgr_MakeMailSlot                      ; 0x0019 ord
  IFSMgr_Service IFSMgr_DeleteMailSlot                    ; 0x001a ord
  IFSMgr_Service IFSMgr_WriteMailSlot                     ; 0x001b ord
  IFSMgr_Service IFSMgr_PopUp                             ; 0x001c ord
  IFSMgr_Service IFSMgr_printf                            ; 0x001d ord
  IFSMgr_Service IFSMgr_AssertFailed                      ; 0x001e ord
  IFSMgr_Service IFSMgr_LogEntry                          ; 0x001f ord
  IFSMgr_Service IFSMgr_DebugMenu                         ; 0x0020 ord
  IFSMgr_Service IFSMgr_DebugVars                         ; 0x0021 ord
  IFSMgr_Service IFSMgr_GetDebugString                    ; 0x0022 ord
  IFSMgr_Service IFSMgr_GetDebugHexNum                    ; 0x0023 ord
  IFSMgr_Service IFSMgr_NetFunction                       ; 0x0024 ord
  IFSMgr_Service IFSMgr_DoDelAllUses                      ; 0x0025 ord
  IFSMgr_Service IFSMgr_SetErrString                      ; 0x0026 ord
  IFSMgr_Service IFSMgr_GetErrString                      ; 0x0027 ord
  IFSMgr_Service IFSMgr_SetReqHook                        ; 0x0028 ord
  IFSMgr_Service IFSMgr_SetPathHook                       ; 0x0029 ord
  IFSMgr_Service IFSMgr_UseAdd                            ; 0x002a ord
  IFSMgr_Service IFSMgr_UseDel                            ; 0x002b ord
  IFSMgr_Service IFSMgr_InitUseAdd                        ; 0x002c ord
  IFSMgr_Service IFSMgr_ChangeDir                         ; 0x002d ord
  IFSMgr_Service IFSMgr_DelAllUses                        ; 0x002e ord
  IFSMgr_Service IFSMgr_CDROM_Attach                      ; 0x002f ord
  IFSMgr_Service IFSMgr_CDROM_Detach                      ; 0x0030 ord
  IFSMgr_Service IFSMgr_Win32DupHandle                    ; 0x0031 ord
  IFSMgr_Service IFSMgr_Ring0_FileIO                      ; 0x0032 ord
  IFSMgr_Service IFSMgr_Win32_Get_Ring0_Handle            ; 0x0033 ord
  IFSMgr_Service IFSMgr_Get_Drive_Info                    ; 0x0034 ord
  IFSMgr_Service IFSMgr_Ring0GetDriveInfo                 ; 0x0035 ord
  IFSMgr_Service IFSMgr_BlockNoEvents                     ; 0x0036 ord
  IFSMgr_Service IFSMgr_NetToDosTime                      ; 0x0037 ord
  IFSMgr_Service IFSMgr_DosToNetTime                      ; 0x0038 ord
  IFSMgr_Service IFSMgr_DosToWin32Time                    ; 0x0039 ord
  IFSMgr_Service IFSMgr_Win32ToDosTime                    ; 0x003a ord
  IFSMgr_Service IFSMgr_NetToWin32Time                    ; 0x003b ord
  IFSMgr_Service IFSMgr_Win32ToNetTime                    ; 0x003c ord
  IFSMgr_Service IFSMgr_MetaMatch                         ; 0x003d ord
  IFSMgr_Service IFSMgr_TransMatch                        ; 0x003e ord
  IFSMgr_Service IFSMgr_CallProvider                      ; 0x003f ord
  IFSMgr_Service UniToBCS                                 ; 0x0040 ord
  IFSMgr_Service UniToBCSPath                             ; 0x0041 ord
  IFSMgr_Service BCSToUni                                 ; 0x0042 ord
  IFSMgr_Service UniToUpper                               ; 0x0043 ord
  IFSMgr_Service UniCharToOEM                             ; 0x0044 ord
  IFSMgr_Service CreateBasis                              ; 0x0045 ord
  IFSMgr_Service MatchBasisName                           ; 0x0046 ord
  IFSMgr_Service AppendBasisTail                          ; 0x0047 ord
  IFSMgr_Service FcbToShort                               ; 0x0048 ord
  IFSMgr_Service ShortToFcb                               ; 0x0049 ord
  IFSMgr_Service IFSMgr_ParsePath                         ; 0x004a ord
  IFSMgr_Service Query_PhysLock                           ; 0x004b ord
  IFSMgr_Service _VolFlush                                ; 0x004c ord
  IFSMgr_Service NotifyVolumeArrival                      ; 0x004d ord
  IFSMgr_Service NotifyVolumeRemoval                      ; 0x004e ord
  IFSMgr_Service QueryVolumeRemoval                       ; 0x004f ord
  IFSMgr_Service IFSMgr_FSDUnmountCFSD                    ; 0x0050 ord
  IFSMgr_Service IFSMgr_GetConversionTablePtrs            ; 0x0051 ord
  IFSMgr_Service IFSMgr_CheckAccessConflict               ; 0x0052 ord
  IFSMgr_Service IFSMgr_LockFile                          ; 0x0053 ord
  IFSMgr_Service IFSMgr_UnlockFile                        ; 0x0054 ord
  IFSMgr_Service IFSMgr_RemoveLocks                       ; 0x0055 ord
  IFSMgr_Service IFSMgr_CheckLocks                        ; 0x0056 ord
  IFSMgr_Service IFSMgr_CountLocks                        ; 0x0057 ord
  IFSMgr_Service IFSMgr_ReassignLockFileInst              ; 0x0058 ord
  IFSMgr_Service IFSMgr_UnassignLockList                  ; 0x0059 ord
  IFSMgr_Service IFSMgr_MountChildVolume                  ; 0x005a ord
  IFSMgr_Service IFSMgr_UnmountChildVolume                ; 0x005b ord
  IFSMgr_Service IFSMgr_SwapDrives                        ; 0x005c ord
  IFSMgr_Service IFSMgr_FSDMapFHtoIOREQ                   ; 0x005d ord
  IFSMgr_Service IFSMgr_FSDParsePath                      ; 0x005e ord
  IFSMgr_Service IFSMgr_FSDAttachSFT                      ; 0x005f ord
  IFSMgr_Service IFSMgr_GetTimeZoneBias                   ; 0x0060 ord
  IFSMgr_Service IFSMgr_PNPEvent                          ; 0x0061 ord
  IFSMgr_Service IFSMgr_RegisterCFSD                      ; 0x0062 ord
  IFSMgr_Service IFSMgr_Win32MapExtendedHandleToSFT       ; 0x0063 ord
  IFSMgr_Service IFSMgr_DbgSetFileHandleLimit             ; 0x0064 ord
  IFSMgr_Service IFSMgr_Win32MapSFTToExtendedHandle       ; 0x0065 ord
  IFSMgr_Service IFSMgr_FSDGetCurrentDrive                ; 0x0066 ord
  IFSMgr_Service IFSMgr_InstallFileSystemApiHook          ; 0x0067 ord
  IFSMgr_Service IFSMgr_RemoveFileSystemApiHook           ; 0x0068 ord
  IFSMgr_Service IFSMgr_RunScheduledEvents                ; 0x0069 ord
  IFSMgr_Service IFSMgr_CheckDelResource                  ; 0x006a ord
  IFSMgr_Service IFSMgr_Win32GetVMCurdir                  ; 0x006b ord
  IFSMgr_Service IFSMgr_SetupFailedConnection             ; 0x006c ord
  IFSMgr_Service _GetMappedErr                            ; 0x006d ord
  IFSMgr_Service ShortToLossyFcb                          ; 0x006e ord
  IFSMgr_Service IFSMgr_GetLockState                      ; 0x006f ord
  IFSMgr_Service BcsToBcs                                 ; 0x0070 ord
  IFSMgr_Service IFSMgr_SetLoopback                       ; 0x0071 ord
  IFSMgr_Service IFSMgr_ClearLoopback                     ; 0x0072 ord
  IFSMgr_Service IFSMgr_ParseOneElement                   ; 0x0073 ord
  IFSMgr_Service BcsToBcsUpper                            ; 0x0074 ord
End_Declare_VxD

Declare_VxD VCDFSD, 0x0041
End_Declare_VxD

Declare_VxD MRCI2, 0x0042
End_Declare_VxD

Declare_VxD PCI, 0x0043
End_Declare_VxD

Declare_VxD PELOADER, 0x0044
End_Declare_VxD

Declare_VxD EISA, 0x0045
End_Declare_VxD

Declare_VxD DRAGCLI, 0x0046
End_Declare_VxD

Declare_VxD DRAGSRV, 0x0047
End_Declare_VxD

Declare_VxD PERF, 0x0048
End_Declare_VxD

Declare_VxD AWREDIR, 0x0049
End_Declare_VxD

Declare_VxD ETEN, 0x0060
End_Declare_VxD

Declare_VxD CHBIOS, 0x0061
End_Declare_VxD

Declare_VxD VMSGD, 0x0062
End_Declare_VxD

Declare_VxD VPPID, 0x0063
End_Declare_VxD

Declare_VxD VIME, 0x0064
End_Declare_VxD

Declare_VxD VHBIOSD, 0x0065
End_Declare_VxD

%macro VxDcall 1-*
  %rep %0 - 1
    %rotate -1
    push %1
  %endrep
  %rotate -1
  db 0xCD, 0x20
  dd %1
  %if %0 > 1
    add esp, 4*(%0 - 1)
  %endif
%endmacro

%define VxDCall VxDcall

%macro VMMcall 1-2+
  %if (%1 >> 16) <> VMM_Device_ID
    %error %1 is not a VMM Service
  %endif
  VxDcall %1, %2
%endmacro

%define VMMCall VMMcall

%endif